# NOTE: Derived from blib/lib/Text/EP3/Verilog.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Text::EP3::Verilog;

#line 355 "blib/lib/Text/EP3/Verilog.pm (autosplit into blib/lib/auto/Text/EP3/Verilog/denum.al)"
sub denum
# usage: @denum a,b,c,d,...
#    As enum, but emits `define and replaces the args with `defs
# Funky enumerated lists by generating multiple define
{
    my $self = shift;
    my ($inline) = @_;		# Single arg: Cmd line
    my (@string,@dlist,$count);
    my ($directive, $key);
    my ($sigstring);
    my ($nbits,$emax,$cntmax, $signals);

    $sigstring = '';

    @string = split(' ',$inline);	# Split at spaces
    print "$self->{Line_Comment}EP3->denum: Entered step.  Line  $Text::EP3::line of $Text::EP3::filename\n"	if $self->{Debug} & 1;
    $directive = shift @string;		# Pop off the @enum
    $signals =  join(' ',@string);	# Put together
    $signals =~ s/ //g;			# Elim spaces
    @dlist = split(',',$signals);	# Split into list at commas
 
 
    # Find The max # bits required...
    $emax = 0;				# default initial value
    foreach $key (@dlist)
    {
	if ( $key =~ /^[0-9]*$/){
	    # We can reinitialize the count at any point
	    if ( $key < $emax){
		croak("Enumerated value can not be LESS than previous value.");
	    }
	    $emax = $key;
	}
	else {
	    $emax++;
	}
    }
    $cntmax=2;
    for($nbits=1; $cntmax <= $emax; $nbits++){
        $cntmax <<= 1;
    }
 
    $count = 0;				# default initial value
    foreach $key (@dlist)
    {
	 if ( $key =~ /^[0-9]*$/){
	     # We can reinitialize the count at any point
	     $count = $key;
	 }
	 else {
	     print "`define ${key}\t${nbits}'d${count}\n";
             # Replace the key with the verilog key
	     $sigstring = "$self->{Delimeter}define $key `$key";
	     $self->define($sigstring);
	     $count++;
	 }
    }    
}

1;
# end of Text::EP3::Verilog::denum
